
CivModels = {

"models/player/gman_high.mdl",
"models/player/breen.mdl",
"models/player/monk.mdl",
"models/player/odessa.mdl",
"models/player/barney.mdl",
"models/player/alyx.mdl",
"models/player/kleiner.mdl",
"models/player/mossman.mdl"

}

local meta = FindMetaTable( "Player" );

function meta:NewData()

	local function ModuleDelay( ply )
	
		umsg.Start( "LoadModules", ply ); 
			umsg.Short( #CSFiles );
			for n = 1, #CSFiles do
				umsg.String( CSFiles[n] );
			end
		umsg.End();
		
	end
	
	timer.Simple( .01, ModuleDelay, self );

	self:SetNWString( "job", "Citizen" );
	
	self:SetNWInt( "money", 300 );
	
	self:GetTable().Pay = 0;
	self:GetTable().LastPayDay = CurTime();
	
	self:GetTable().Owned = { }
	self:GetTable().OwnedNum = 0;
	
	self:GetTable().LastLetterMade = CurTime();
	self:GetTable().LastVoteCop = CurTime();
	
	self:SetTeam( 1 );
	
	if( self:IsSuperAdmin() or self:IsAdmin() ) then
	
		Admins[self:SteamID()] = { }
	
	end
	
end

function meta:CanAfford( amount ) 

	if( amount < 0 ) then return false; end

	if( self:GetNWInt( "money" ) - amount < 0 ) then
		return false;
	end
	
	return true;

end

function meta:AddMoney( amount )

	local oldamount = self:GetNWInt( "money" );
	
	self:SetNWInt( "money", oldamount + amount );

end

function meta:PayDay()

	if( self:GetTable().Pay == 1 ) then
	
		local amount = 0;
	
		if( self:Team() == 1 ) then
			amount = math.random( 35, 60 );
			self:AddMoney( amount );
		else
			amount = math.random( 50, 80 );
			self:AddMoney( amount );
		end
		
		Notify( self, 4, 4, "Payday! You got " .. amount .. " bucks!" );
	
	end

end

function meta:UpdateJob( job )

	self:SetNWString( "job", job );

	if( string.lower( job ) ~= "unemployed" and
		string.lower( job ) ~= "bum" and
		string.lower( job ) ~= "hobo" ) then
		
		self:GetTable().Pay = 1;
		self:GetTable().LastPayDay = CurTime();
		
		timer.Create( self:SteamID() .. "jobtimer", CfgVars["paydelay"], 0, self.PayDay, self );
		
	else
	
		timer.Destroy( self:SteamID() .. "jobtimer" );
	
	end

end

function meta:Arrest()

	self:StripWeapons();
	self:GetTable().Arrested = true;
	
end

function meta:Unarrest()

	self:GetTable().Arrested = false;
	
	GAMEMODE:PlayerLoadout( self );

end

function meta:UnownAllShit()

	for k, v in pairs( self:GetTable().Owned ) do
		
		v:UnOwn( self );
		self:GetTable().Owned[v:EntIndex()] = nil;
		
	end
	
	for k, v in pairs( player.GetAll() ) do
	
		for n, m in pairs( v:GetTable().Owned ) do
		
			if( m:AllowedToOwn( self ) ) then
				m:RemoveAllowed( self );
			end
		
		end
	
	end
	
	self:GetTable().OwnedNum = 0;

end

function meta:DoPropertyTax()

	if( CfgVars["propertytax"] == 0 ) then return; end
	if( ( self:Team() == 2 or self:Team() == 3 ) and CfgVars["cit_propertytax"] == 1 ) then return; end

	local numowned = self:GetTable().OwnedNum;
	if( numowned <= 0 ) then return; end
	
	local price = 10;
	local tax = price * numowned + math.random( -10, 10 );
	
	if( self:CanAfford( tax ) ) then

		self:AddMoney( -tax );
		Notify( self, 1, 5, "Property tax! $" .. tax );
		
	else

		Notify( self, 1, 8, "Can't pay the taxes! Your property has been taken away from you" );
		self:UnownAllShit();
	
	end

end

function GM:PlayerDeath( ply, weapon, killer )

	self.BaseClass:PlayerDeath( ply, weapon, killer );

	ply:GetTable().DeathPos = ply:GetPos();

	if( ply ~= killer or ply:GetTable().Slayed ) then
	
		ply:GetTable().Arrested = false;
		ply:GetTable().DeathPos = nil;
	
		ply:GetTable().Slayed = false;
	
	end

end


function GM:PlayerCanPickupWeapon( ply, class )

	if( ply:GetTable().Arrested ) then return false; end

	return true;

end

function GM:PlayerSpawn( ply )

	self.BaseClass:PlayerSpawn( ply );
	
	ply:CrosshairEnable();
	
	if( CfgVars["crosshair"] == 0 ) then
	
		ply:CrosshairDisable();
	
	end
	
	if( CfgVars["strictsuicide"] == 1 and ply:GetTable().DeathPos ) then
	
		ply:SetPos( ply:GetTable().DeathPos );
	
	end
	
	if( ply:GetTable().Arrested ) then
	
		ply:SetPos( ply:GetTable().DeathPos );
		ply:Arrest();
	
	end
	
	if( ply:Team() == 1 and CfgVars["enforceplayermodel"] == 1 ) then
		
		local validmodel = false;
		
		for k, v in pairs( CivModels ) do
				
			if( ply:GetTable().PlayerModel == v ) then
					
				validmodel = true;
				break;
					
			end
				
		end		
			
		if( not validmodel ) then
			ply:GetTable().PlayerModel = nil;
		end
		
		local model = ply:GetModel();
			
		if( model ~= ply:GetTable().PlayerModel ) then
			
			for k, v in pairs( CivModels ) do
				
				if( v == model ) then
					
					ply:GetTable().PlayerModel = model;
					validmodel = true;
					break;
					
				end
				
			end
				
			if( not validmodel and not ply:GetTable().PlayerModel ) then
				
				ply:GetTable().PlayerModel = CivModels[math.random( 1, #CivModels )];
				
			end
				
			ply:SetModel( ply:GetTable().PlayerModel );
				
		end
			
	elseif( ply:Team() == 2 ) then
		
		ply:SetModel( "models/player/police.mdl" );
			
	elseif( ply:Team() == 3 ) then
		
		ply:SetModel( "models/player/combine_super_soldier.mdl" );
		
	end

end

function GM:PlayerLoadout( ply )

	if( ply:GetTable().Arrested ) then return; end

	local team = ply:Team();

	ply:Give( "weapon_physcannon" );
	ply:Give( "weapon_physgun" );
	ply:Give( "keys" );
	
	if( Admins[ply:SteamID()] or CfgVars["toolgun"] == 1 ) then
	
		ply:Give( "gmod_tool" );
	
	end
	
	--CPs
	if( team == 2 ) then
	
		ply:Give( "weapon_pistol" );
		ply:Give( "weapon_smg1" );
		
		ply:Give( "door_ram" );
		ply:Give( "arrest_stick" );
		ply:Give( "stunstick" );
		
		ply:GiveAmmo( 32, "Pistol" );
		ply:GiveAmmo( 40, "SMG1" );
	
	--OW
	elseif( team == 3 ) then
	
		ply:Give( "weapon_pistol" );
		ply:Give( "weapon_smg1" );
		ply:Give( "weapon_ar2" );
		ply:Give( "weapon_shotgun" );
		
		ply:Give( "door_ram" );
		ply:Give( "arrest_stick" );
		ply:Give( "stunstick" );
		
		ply:GiveAmmo( 32, "Pistol" );
		ply:GiveAmmo( 80, "SMG1" );
		ply:GiveAmmo( 64, "AR2" );
		ply:GiveAmmo( 16, "Buckshot" );
		
	end

end

function GM:PlayerInitialSpawn( ply )

	self.BaseClass:PlayerInitialSpawn( ply );
	
	ply:NewData();
	NetworkHelpLabels( ply );
	
end

function GM:PlayerDisconnected( ply )

	self.BaseClass:PlayerDisconnected( ply );
	
	ply:UnownAllShit();
	
	timer.Destroy( ply:SteamID() .. "jobtimer" );
	timer.Destroy( ply:SteamID() .. "propertytax" );
	
	vote.DestroyVotesWithEnt( ply );

end